import React from 'react';
import { ACTION } from '../constants';
import { IHistory } from '../util';
export declare const useHistory: () => {
    history: IHistory[];
    currentId: string;
    renderNewCanvas: (id?: string) => void;
    handleRedo: () => void;
    handleUndo: () => void;
    updateCanvasState: (action: ACTION, remove?: boolean, append?: boolean) => void;
};
/** 历史 */
export declare const History: React.ForwardRefExoticComponent<React.RefAttributes<unknown>>;
