/// <reference types="react" />
import { ACTION, IDownloadBody, MENU_TYPE_ENUM } from '../constants';
interface IProps {
    url: string;
}
/** 初始化图像编辑组件 */
export declare const useInit: ({ url }: IProps) => {
    canvasEl: import("react").RefObject<HTMLCanvasElement>;
    imageInstanceRef: import("react").MutableRefObject<any>;
    canvasInstanceRef: import("react").MutableRefObject<any>;
    wrapperInstanceRef: import("react").RefObject<HTMLDivElement>;
    currentMenu: MENU_TYPE_ENUM;
    setCurrentMenu: (newMenu: MENU_TYPE_ENUM) => void;
    currentMenuRef: import("react").MutableRefObject<MENU_TYPE_ENUM>;
    canvasIsRender: boolean;
    initCanvasJson: import("react").MutableRefObject<string>;
    unSaveHistory: import("react").MutableRefObject<boolean>;
    historyRef: import("react").MutableRefObject<{
        updateCanvasState: (action: ACTION, remove: boolean, append: boolean) => void;
    }>;
    initBackGroundImage: (imageUrl?: string, justBackground?: boolean, callback?: () => void) => void;
    downloadRef: import("react").MutableRefObject<{
        downLoad: (auto?: boolean) => Promise<IDownloadBody>;
    }>;
    zoom: number;
    setZoom: import("react").Dispatch<import("react").SetStateAction<number>>;
};
export {};
