/* eslint-disable @typescript-eslint/no-unused-vars */
/* eslint-disable @typescript-eslint/no-unused-expressions */
import React from 'react';
import { paintConfig } from "../../constants";
import Popover from "./Popover";
/** 马赛克参数 */
var MosaicPop = function MosaicPop(_ref) {
  var children = _ref.children,
    _ref$open = _ref.open,
    open = _ref$open === void 0 ? false : _ref$open,
    onChange = _ref.onChange;
  var handleSizeChange = function handleSizeChange(value) {
    onChange && onChange(value);
  };
  return /*#__PURE__*/React.createElement(Popover, {
    content: /*#__PURE__*/React.createElement("div", {
      className: "tie-image-editor_tool-crop-pop"
    }, /*#__PURE__*/React.createElement("div", {
      className: "tie-image-editor_tool-paint-size-wrapper"
    }, paintConfig.mosaicSizes.map(function (size, index) {
      return /*#__PURE__*/React.createElement("div", {
        onClick: function onClick() {
          return handleSizeChange(size);
        },
        key: size,
        className: "tie-image-editor_tool-paint-size",
        style: {
          width: 10 + index * 5,
          height: 10 + index * 5
        }
      });
    }))),
    placement: "bottom",
    open: open
  }, /*#__PURE__*/React.createElement("div", null, children));
};
export default MosaicPop;