var _excluded = ["className", "style", "children", "trigger", "visible", "popoverClassName", "popoverStyle", "showArrow", "content", "placement", "usePortal", "portalContainer", "positionFixed", "modifiers", "outlineColor", "backgroundColor", "scheduleUpdate", "onOpenChange", "maskClosable"];
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/* eslint-disable @typescript-eslint/ban-types */
/* eslint-disable @typescript-eslint/no-unused-expressions */
import classNames from 'classnames';
import React, { useEffect, useRef, useState } from 'react';
import { Manager, Popper, Reference } from 'react-popper';
import { removeNonHTMLProps } from "../../util";
import Portal from "./Portal";
var ArrowWrapper = function ArrowWrapper(props) {
  return /*#__PURE__*/React.createElement("div", {
    className: "popper__arrow",
    style: _defineProperty({}, 'border' + (((props === null || props === void 0 ? void 0 : props.arrowPlacement[0]) || '').toLocaleUpperCase() + (props.arrowPlacement || '').substring(1)) + 'Color', props.backgroundColor)
  }, props.children);
};
var Popover = function Popover(props) {
  var popoverRef = useRef(null);
  var targetRef = useRef(null);
  var _useState = useState(props.open),
    _useState2 = _slicedToArray(_useState, 2),
    open = _useState2[0],
    setOpen = _useState2[1];
  var className = props.className,
    style = props.style,
    children = props.children,
    trigger = props.trigger,
    visible = props.visible,
    popoverClassName = props.popoverClassName,
    popoverStyle = props.popoverStyle,
    showArrow = props.showArrow,
    content = props.content,
    placement = props.placement,
    usePortal = props.usePortal,
    portalContainer = props.portalContainer,
    positionFixed = props.positionFixed,
    modifiers = props.modifiers,
    outlineColor = props.outlineColor,
    backgroundColor = props.backgroundColor,
    scheduleUpdate = props.scheduleUpdate,
    onOpenChange = props.onOpenChange,
    _props$maskClosable = props.maskClosable,
    maskClosable = _props$maskClosable === void 0 ? true : _props$maskClosable,
    restProps = _objectWithoutProperties(props, _excluded);
  var domProps = removeNonHTMLProps(restProps, ['popoverClassName', 'popoverStyle', 'showArrow', 'content', 'usePortal', 'positionFixed', 'outlineColor', 'backgroundColor', 'getPopoverRef', 'onOpenChange']);
  var handleOpenChange = function handleOpenChange(openState) {
    if (onOpenChange) {
      onOpenChange(openState);
    }
    if (props.open !== undefined) {
      setOpen(props.open);
    } else {
      setOpen(openState);
    }
  };
  var handleClick = function handleClick(e) {
    var _current, _current2;
    if (!popoverRef || !targetRef) return;
    if ((_current = popoverRef.current) !== null && _current !== void 0 && _current.contains(e.target) || (_current2 = targetRef.current) !== null && _current2 !== void 0 && _current2.contains(e.target)) {
      return;
    }
    if (maskClosable) {
      handleOpenChange(false);
    }
  };
  var mouseEnter = function mouseEnter() {
    var open = props.open,
      onOpenChange = props.onOpenChange;
    if (open !== undefined && onOpenChange === undefined) return;
    if (trigger === 'hover') {
      handleOpenChange(true);
    }
  };
  var mouseLeave = function mouseLeave() {
    var open = props.open,
      onOpenChange = props.onOpenChange;
    if (open !== undefined && onOpenChange === undefined) return;
    if (trigger === 'hover') {
      handleOpenChange(false);
    }
  };
  var handleVisiblePopover = function handleVisiblePopover(e) {
    e.nativeEvent.stopImmediatePropagation();
    if (trigger === 'click') {
      handleOpenChange(!open);
      return;
    }
    if (trigger === 'focus') {
      handleOpenChange(true);
    }
  };
  useEffect(function () {
    if (props.getPopoverRef) {
      props.getPopoverRef(popoverRef);
    }
  }, []);
  useEffect(function () {
    if (trigger === 'click' || trigger === 'focus') {
      document.body.addEventListener('click', handleClick, false);
    }
    return function () {
      document.body.removeEventListener('click', handleClick, false);
    };
  }, [maskClosable, props.open]);
  useEffect(function () {
    if (props.open !== undefined) {
      handleOpenChange(props.open);
    }
  }, [props.open]);

  /**
   * 渲染 popover 弹层
   */
  var renderPopper = function renderPopper() {
    var strategy = positionFixed ? 'fixed' : 'absolute';
    var defaultModifiers = [{
      name: 'computeStyles',
      options: {
        gpuAcceleration: false // true by default
      }
    }, {
      name: 'offset',
      options: {
        offset: [0, 10]
      }
    }];

    // 获取（placement）方向并把首字母设置成大写
    var direction = function direction(placement) {
      if (placement) {
        return placement.split('-')[0].toString().replace(/^\S/, function (s) {
          return s.toUpperCase();
        });
      }
    };

    // 设置popover的边框和（arrow）三角形的边框颜色
    var getOutlineColor = function getOutlineColor(type) {
      if (type === 'content' && outlineColor) {
        return {
          borderColor: outlineColor
        };
      }
      if (type === 'arrow' && outlineColor) {
        return _defineProperty({}, "border".concat(direction(placement), "Color"), outlineColor);
      }
    };

    // 设置popover的背景
    var getBackgroundColor = function getBackgroundColor() {
      if (backgroundColor) {
        return {
          color: '#fff',
          background: backgroundColor
          // border: 'none',
        };
      }
    };

    // 动态设置三角的背景色
    var arrowPlacement = placement.split('-')[0];
    var popperContent = open && /*#__PURE__*/React.createElement(Popper, {
      placement: placement,
      modifiers: [].concat(defaultModifiers, _toConsumableArray(modifiers ? modifiers : [])),
      strategy: strategy
    }, function (_ref3) {
      var ref = _ref3.ref,
        style = _ref3.style,
        placement = _ref3.placement,
        arrowProps = _ref3.arrowProps,
        update = _ref3.update;
      // eslint-disable-next-line react-hooks/rules-of-hooks
      useEffect(function () {
        if (open) {
          update();
        }
      }, [scheduleUpdate]);
      return /*#__PURE__*/React.createElement("div", {
        className: classNames('tie-popover__popper', popoverClassName, {
          'tie-popover__popper-background': backgroundColor
        }),
        style: _objectSpread(_objectSpread(_objectSpread(_objectSpread({}, style), popoverStyle), getOutlineColor('content')), getBackgroundColor()),
        ref: ref
        // eslint-disable-next-line react/no-unknown-property
        ,
        "x-placement": placement,
        onMouseEnter: mouseEnter,
        onMouseLeave: mouseLeave
      }, /*#__PURE__*/React.createElement("div", {
        ref: popoverRef
      }, open && /*#__PURE__*/React.createElement("div", {
        className: "tie-popover__content"
      }, /*#__PURE__*/React.createElement("span", null, content)), showArrow && /*#__PURE__*/React.createElement(ArrowWrapper, {
        arrowPlacement: arrowPlacement,
        backgroundColor: backgroundColor
      }, /*#__PURE__*/React.createElement("div", {
        "data-popper-arrow": true,
        className: "tie-popper__arrow popper__arrow"
        // eslint-disable-next-line react/no-unknown-property
        ,
        "x-arrow": "true",
        style: _objectSpread(_objectSpread({}, arrowProps.style), getOutlineColor('arrow')),
        ref: arrowProps.ref
      }))));
    });
    return usePortal ? /*#__PURE__*/React.createElement(Portal, {
      container: portalContainer
    }, popperContent) : popperContent;
  };

  // 解决children为Button元素且禁用的时候鼠标事件失效的问题
  var getDisabledCompatibleChildren = function getDisabledCompatibleChildren(element) {
    if (element.type.__BRICKS_BUTTON && element.props.disabled) {
      var displayStyle = element.props.style && element.props.style.display ? element.props.style.display : 'inline-block';
      var child = /*#__PURE__*/React.cloneElement(element, {
        style: _objectSpread(_objectSpread({}, element.props.style), {}, {
          pointerEvents: 'none'
        })
      });
      return /*#__PURE__*/React.createElement("span", {
        style: {
          display: displayStyle,
          cursor: 'not-allowed'
        }
      }, child);
    }
    return element;
  };
  return /*#__PURE__*/React.createElement(React.Fragment, null, visible ? /*#__PURE__*/React.createElement("div", _extends({
    className: classNames('tie-popover', className)
  }, domProps, {
    style: style
  }), /*#__PURE__*/React.createElement(Manager, null, /*#__PURE__*/React.createElement(Reference, null, function (_ref4) {
    var ref = _ref4.ref;
    return /*#__PURE__*/React.createElement("div", {
      ref: targetRef,
      className: "tie-popover__target"
    }, /*#__PURE__*/React.createElement("div", {
      ref: ref
    }, React.Children.map(children, function (child) {
      var ele = child;
      ele = getDisabledCompatibleChildren(ele);
      if (trigger === 'click') {
        return /*#__PURE__*/React.cloneElement(ele, {
          onClick: function onClick(e) {
            handleVisiblePopover(e);
            ele.props.onClick && ele.props.onClick();
          }
        });
      }
      if (trigger === 'focus') {
        return /*#__PURE__*/React.cloneElement(ele, {
          onFocus: function onFocus(e) {
            handleVisiblePopover(e);
            ele.props.onFocus && ele.props.onFocus();
          }
        });
      }
      if (trigger === 'hover') {
        return /*#__PURE__*/React.cloneElement(ele, {
          onMouseEnter: function onMouseEnter() {
            mouseEnter();
            ele.props.onMouseEnter && ele.props.onMouseEnter();
          },
          onMouseLeave: function onMouseLeave() {
            mouseLeave();
            ele.props.onMouseLeave && ele.props.onMouseLeave();
          }
        });
      }
      return ele;
    })));
  }), renderPopper())) : children);
};
Popover.defaultProps = {
  visible: true,
  trigger: 'hover',
  placement: 'bottom',
  showArrow: true,
  usePortal: true,
  modifiers: []
};
export default Popover;