var _MENU_TYPE_ENUM$crop, _MENU_TYPE_ENUM$histo, _MENU_TYPE_ENUM$downl, _MENU_TYPE_ENUM$draw, _MENU_TYPE_ENUM$flip, _MENU_TYPE_ENUM$reset, _MENU_TYPE_ENUM$rotat, _MENU_TYPE_ENUM$rect, _MENU_TYPE_ENUM$circl, _MENU_TYPE_ENUM$text, _MENU_TYPE_ENUM$uploa, _MENU_TYPE_ENUM$drag, _MENU_TYPE_ENUM$scale, _MENU_TYPE_ENUM$arrow, _MENU_TYPE_ENUM$mosai, _MENU_TYPE_ENUM$redo, _MENU_TYPE_ENUM$undo, _MENU_TYPE_TEXT, _ACTION_TEXT;
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
export var eventNames = {
  OBJECT_ACTIVATED: 'objectActivated',
  OBJECT_MOVED: 'objectMoved',
  OBJECT_SCALED: 'objectScaled',
  OBJECT_CREATED: 'objectCreated',
  TEXT_EDITING: 'textEditing',
  TEXT_CHANGED: 'textChanged',
  ICON_CREATE_RESIZE: 'iconCreateResize',
  ICON_CREATE_END: 'iconCreateEnd',
  ADD_TEXT: 'addText',
  ADD_OBJECT: 'addObject',
  ADD_OBJECT_AFTER: 'addObjectAfter',
  MOUSE_DOWN: 'mousedown',
  MOUSE_UP: 'mouseup',
  MOUSE_MOVE: 'mousemove',
  // UNDO/REDO Events
  REDO_STACK_CHANGED: 'redoStackChanged',
  UNDO_STACK_CHANGED: 'undoStackChanged',
  SELECTION_CLEARED: 'selectionCleared',
  SELECTION_CREATED: 'selectionCreated'
};

/** 菜单 */
export var MENU_TYPE_ENUM = /*#__PURE__*/function (MENU_TYPE_ENUM) {
  MENU_TYPE_ENUM["crop"] = "crop";
  MENU_TYPE_ENUM["history"] = "history";
  MENU_TYPE_ENUM["download"] = "download";
  MENU_TYPE_ENUM["draw"] = "draw";
  MENU_TYPE_ENUM["flip"] = "flip";
  MENU_TYPE_ENUM["reset"] = "reset";
  MENU_TYPE_ENUM["rotate"] = "rotate";
  MENU_TYPE_ENUM["rect"] = "rect";
  MENU_TYPE_ENUM["circle"] = "circle";
  MENU_TYPE_ENUM["text"] = "text";
  MENU_TYPE_ENUM["upload"] = "upload";
  MENU_TYPE_ENUM["drag"] = "drag";
  MENU_TYPE_ENUM["scale"] = "scale";
  MENU_TYPE_ENUM["arrow"] = "arrow";
  MENU_TYPE_ENUM["mosaic"] = "mosaic";
  MENU_TYPE_ENUM["undo"] = "undo";
  MENU_TYPE_ENUM["redo"] = "redo";
  MENU_TYPE_ENUM["default"] = "";
  return MENU_TYPE_ENUM;
}({});
export var LANG = /*#__PURE__*/function (LANG) {
  LANG["zh"] = "zh";
  LANG["en"] = "en";
  return LANG;
}({});
export var MENU_TYPE_TEXT = (_MENU_TYPE_TEXT = {}, _defineProperty(_MENU_TYPE_TEXT, MENU_TYPE_ENUM.crop, (_MENU_TYPE_ENUM$crop = {}, _defineProperty(_MENU_TYPE_ENUM$crop, LANG.zh, '裁剪'), _defineProperty(_MENU_TYPE_ENUM$crop, LANG.en, MENU_TYPE_ENUM.crop), _MENU_TYPE_ENUM$crop)), _defineProperty(_MENU_TYPE_TEXT, MENU_TYPE_ENUM.history, (_MENU_TYPE_ENUM$histo = {}, _defineProperty(_MENU_TYPE_ENUM$histo, LANG.zh, '历史记录'), _defineProperty(_MENU_TYPE_ENUM$histo, LANG.en, MENU_TYPE_ENUM.history), _MENU_TYPE_ENUM$histo)), _defineProperty(_MENU_TYPE_TEXT, MENU_TYPE_ENUM.download, (_MENU_TYPE_ENUM$downl = {}, _defineProperty(_MENU_TYPE_ENUM$downl, LANG.zh, '下载'), _defineProperty(_MENU_TYPE_ENUM$downl, LANG.en, MENU_TYPE_ENUM.download), _MENU_TYPE_ENUM$downl)), _defineProperty(_MENU_TYPE_TEXT, MENU_TYPE_ENUM.draw, (_MENU_TYPE_ENUM$draw = {}, _defineProperty(_MENU_TYPE_ENUM$draw, LANG.zh, '画笔'), _defineProperty(_MENU_TYPE_ENUM$draw, LANG.en, MENU_TYPE_ENUM.draw), _MENU_TYPE_ENUM$draw)), _defineProperty(_MENU_TYPE_TEXT, MENU_TYPE_ENUM.flip, (_MENU_TYPE_ENUM$flip = {}, _defineProperty(_MENU_TYPE_ENUM$flip, LANG.zh, '翻转'), _defineProperty(_MENU_TYPE_ENUM$flip, LANG.en, MENU_TYPE_ENUM.flip), _MENU_TYPE_ENUM$flip)), _defineProperty(_MENU_TYPE_TEXT, MENU_TYPE_ENUM.reset, (_MENU_TYPE_ENUM$reset = {}, _defineProperty(_MENU_TYPE_ENUM$reset, LANG.zh, '重置'), _defineProperty(_MENU_TYPE_ENUM$reset, LANG.en, MENU_TYPE_ENUM.reset), _MENU_TYPE_ENUM$reset)), _defineProperty(_MENU_TYPE_TEXT, MENU_TYPE_ENUM.rotate, (_MENU_TYPE_ENUM$rotat = {}, _defineProperty(_MENU_TYPE_ENUM$rotat, LANG.zh, '旋转'), _defineProperty(_MENU_TYPE_ENUM$rotat, LANG.en, MENU_TYPE_ENUM.rotate), _MENU_TYPE_ENUM$rotat)), _defineProperty(_MENU_TYPE_TEXT, MENU_TYPE_ENUM.rect, (_MENU_TYPE_ENUM$rect = {}, _defineProperty(_MENU_TYPE_ENUM$rect, LANG.zh, '矩形'), _defineProperty(_MENU_TYPE_ENUM$rect, LANG.en, MENU_TYPE_ENUM.rect), _MENU_TYPE_ENUM$rect)), _defineProperty(_MENU_TYPE_TEXT, MENU_TYPE_ENUM.circle, (_MENU_TYPE_ENUM$circl = {}, _defineProperty(_MENU_TYPE_ENUM$circl, LANG.zh, '圆形'), _defineProperty(_MENU_TYPE_ENUM$circl, LANG.en, MENU_TYPE_ENUM.circle), _MENU_TYPE_ENUM$circl)), _defineProperty(_MENU_TYPE_TEXT, MENU_TYPE_ENUM.text, (_MENU_TYPE_ENUM$text = {}, _defineProperty(_MENU_TYPE_ENUM$text, LANG.zh, '文本'), _defineProperty(_MENU_TYPE_ENUM$text, LANG.en, MENU_TYPE_ENUM.text), _MENU_TYPE_ENUM$text)), _defineProperty(_MENU_TYPE_TEXT, MENU_TYPE_ENUM.upload, (_MENU_TYPE_ENUM$uploa = {}, _defineProperty(_MENU_TYPE_ENUM$uploa, LANG.zh, '上传'), _defineProperty(_MENU_TYPE_ENUM$uploa, LANG.en, MENU_TYPE_ENUM.upload), _MENU_TYPE_ENUM$uploa)), _defineProperty(_MENU_TYPE_TEXT, MENU_TYPE_ENUM.drag, (_MENU_TYPE_ENUM$drag = {}, _defineProperty(_MENU_TYPE_ENUM$drag, LANG.zh, '拖拽'), _defineProperty(_MENU_TYPE_ENUM$drag, LANG.en, MENU_TYPE_ENUM.drag), _MENU_TYPE_ENUM$drag)), _defineProperty(_MENU_TYPE_TEXT, MENU_TYPE_ENUM.scale, (_MENU_TYPE_ENUM$scale = {}, _defineProperty(_MENU_TYPE_ENUM$scale, LANG.zh, '缩放'), _defineProperty(_MENU_TYPE_ENUM$scale, LANG.en, MENU_TYPE_ENUM.scale), _MENU_TYPE_ENUM$scale)), _defineProperty(_MENU_TYPE_TEXT, MENU_TYPE_ENUM.arrow, (_MENU_TYPE_ENUM$arrow = {}, _defineProperty(_MENU_TYPE_ENUM$arrow, LANG.zh, '箭头'), _defineProperty(_MENU_TYPE_ENUM$arrow, LANG.en, MENU_TYPE_ENUM.arrow), _MENU_TYPE_ENUM$arrow)), _defineProperty(_MENU_TYPE_TEXT, MENU_TYPE_ENUM.mosaic, (_MENU_TYPE_ENUM$mosai = {}, _defineProperty(_MENU_TYPE_ENUM$mosai, LANG.zh, '马赛克'), _defineProperty(_MENU_TYPE_ENUM$mosai, LANG.en, MENU_TYPE_ENUM.mosaic), _MENU_TYPE_ENUM$mosai)), _defineProperty(_MENU_TYPE_TEXT, MENU_TYPE_ENUM.redo, (_MENU_TYPE_ENUM$redo = {}, _defineProperty(_MENU_TYPE_ENUM$redo, LANG.zh, '前进'), _defineProperty(_MENU_TYPE_ENUM$redo, LANG.en, MENU_TYPE_ENUM.redo), _MENU_TYPE_ENUM$redo)), _defineProperty(_MENU_TYPE_TEXT, MENU_TYPE_ENUM.undo, (_MENU_TYPE_ENUM$undo = {}, _defineProperty(_MENU_TYPE_ENUM$undo, LANG.zh, '后退'), _defineProperty(_MENU_TYPE_ENUM$undo, LANG.en, MENU_TYPE_ENUM.undo), _MENU_TYPE_ENUM$undo)), _MENU_TYPE_TEXT);

/** 鼠标形状 */
export var CURSOR = /*#__PURE__*/function (CURSOR) {
  CURSOR["default"] = "default";
  CURSOR["crosshair"] = "crosshair";
  CURSOR["pointer"] = "pointer";
  CURSOR["move"] = "move";
  CURSOR["grab"] = "grab";
  CURSOR["grabbing"] = "grabbing";
  CURSOR["zoomIn"] = "zoom-in";
  CURSOR["zoomOut"] = "zoom-out";
  return CURSOR;
}({});
export var ACTION = /*#__PURE__*/function (ACTION) {
  ACTION["add"] = "add";
  ACTION["modified"] = "modified";
  ACTION["delete"] = "delete";
  return ACTION;
}({});
export var ACTION_TEXT = (_ACTION_TEXT = {}, _defineProperty(_ACTION_TEXT, ACTION.add, '添加'), _defineProperty(_ACTION_TEXT, ACTION.modified, '修改'), _defineProperty(_ACTION_TEXT, ACTION.delete, '删除'), _ACTION_TEXT);
export var FLIP_TYPE = /*#__PURE__*/function (FLIP_TYPE) {
  FLIP_TYPE["flipX"] = "flipX";
  FLIP_TYPE["flipY"] = "flipY";
  return FLIP_TYPE;
}({});
export var WORK_SPACE_ID = 'workspace';
export var IPaintTypes = /*#__PURE__*/function (IPaintTypes) {
  IPaintTypes["size"] = "size";
  IPaintTypes["color"] = "color";
  return IPaintTypes;
}({}); //颜色

/** 一些绘画配置 */
export var paintConfig = {
  sizes: [5, 10, 20],
  //通用画笔尺寸
  colors: ['red', 'orange', 'yellow', 'green', 'blue', 'white'],
  //通用画笔颜色
  fontSizes: [30, 60, 90],
  //通用文字颜色
  rotates: [0, 45, 90, 135, 180, 225, 270, 315, 360],
  //通用旋转角度
  mosaicSizes: [10, 20, 30] //马赛克大小
};

/** 下载函数参数 */

export var keyCodes = {
  Z: 90,
  Y: 89,
  SHIFT: 16,
  BACKSPACE: 8,
  DEL: 46
};
export var IMAGE_NAME = 'tie_image_editor';
export var DEFAULT_DIMENSION = 8;

/** 前进和回退时保留的属性 */
export var stayRemain = ['id', 'gradientAngle', 'selectable', 'hasControls', 'source', 'editable'];

/** 最大历史长度 */
export var MAX_HISTORY_LEN = 30;
/** 空值 */
export var EMPTY_STR = '';
export var EMPTY_ARR = [];
/** 原生dom事件的interface */

/** 通用的需要从 props 过滤掉的不属于 dom 的属性 */
export var INVALID_PROPS = ['onChange', 'loadData', 'onClick', 'onSelect', 'options', 'name', 'value', 'defaultValue', 'values', 'defaultValues', 'placeholder', 'large', 'small', 'iconRender', 'icon', 'activeIndex', 'swipeAble', 'fixedArrows', 'error', 'onVisibleChange'];