function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
/* eslint-disable @typescript-eslint/no-unused-vars */
/* eslint-disable @typescript-eslint/no-unused-expressions */
import React, { useState } from 'react';
import { FLIP_TYPE } from "../../constants";
import Popover from "./Popover";
/** 旋转参数 */
var FlipPop = function FlipPop(_ref) {
  var children = _ref.children,
    _ref$open = _ref.open,
    open = _ref$open === void 0 ? false : _ref$open,
    onChange = _ref.onChange;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    flipX = _useState2[0],
    setFlipX = _useState2[1];
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    flipY = _useState4[0],
    setFlipY = _useState4[1];
  var handleAngelChange = function handleAngelChange(type, value) {
    if (type === FLIP_TYPE.flipX) {
      setFlipX(value);
    } else {
      setFlipY(value);
    }
    onChange && onChange(type, value);
  };
  return /*#__PURE__*/React.createElement(Popover, {
    content: /*#__PURE__*/React.createElement("div", {
      className: "tie-image-editor_tool-flip-pop"
    }, /*#__PURE__*/React.createElement("div", {
      className: "tie-image-editor_tool-item tie-image-editor_tool-flipX",
      onClick: function onClick() {
        return handleAngelChange(FLIP_TYPE.flipX, !flipX);
      }
    }, /*#__PURE__*/React.createElement("i", {
      className: "tie-image-editor_icon"
    })), /*#__PURE__*/React.createElement("div", {
      className: "tie-image-editor_tool-item tie-image-editor_tool-flipY",
      onClick: function onClick() {
        return handleAngelChange(FLIP_TYPE.flipY, !flipY);
      }
    }, /*#__PURE__*/React.createElement("i", {
      className: "tie-image-editor_icon"
    }))),
    placement: "bottom",
    open: open
  }, /*#__PURE__*/React.createElement("div", null, children));
};
export default FlipPop;