/* eslint-disable @typescript-eslint/no-unused-vars */
/* eslint-disable @typescript-eslint/no-unused-expressions */
import React from 'react';
import { IPaintTypes, MENU_TYPE_ENUM, paintConfig } from "../../constants";
import Popover from "./Popover";
var Paint = function Paint(_ref) {
  var children = _ref.children,
    _ref$open = _ref.open,
    open = _ref$open === void 0 ? false : _ref$open,
    type = _ref.type,
    onChange = _ref.onChange;
  var handleChange = function handleChange(type, value) {
    onChange && onChange(type, value);
  };
  return /*#__PURE__*/React.createElement(Popover, {
    content: /*#__PURE__*/React.createElement("div", {
      className: "tie-image-editor_tool-paint-content"
    }, /*#__PURE__*/React.createElement("div", {
      className: "tie-image-editor_tool-paint-size-wrapper"
    }, (type === MENU_TYPE_ENUM.text ? paintConfig.fontSizes : paintConfig.sizes).map(function (size, index) {
      return /*#__PURE__*/React.createElement("div", {
        onClick: function onClick() {
          return handleChange(IPaintTypes.size, size);
        },
        key: size,
        className: "tie-image-editor_tool-paint-size",
        style: {
          width: 10 + index * 5,
          height: 10 + index * 5
        }
      });
    })), /*#__PURE__*/React.createElement("div", {
      className: "tie-image-editor_tool-paint-color-wrapper"
    }, paintConfig.colors.map(function (color) {
      return /*#__PURE__*/React.createElement("div", {
        onClick: function onClick() {
          return handleChange(IPaintTypes.color, color);
        },
        key: color,
        className: "tie-image-editor_tool-paint-color",
        style: {
          background: color
        }
      });
    }))),
    placement: "bottom",
    open: open
  }, /*#__PURE__*/React.createElement("div", null, children));
};
export default Paint;