import React from 'react';
export interface IPortalProps {
    container?: Element;
    children?: React.ReactNode;
    onRendered?: () => void;
}
export default class Portal extends React.Component<IPortalProps, {}> {
    container: null | Element;
    constructor(props: IPortalProps);
    componentDidMount(): void;
    componentDidUpdate(prevProps: IPortalProps): void;
    getContainer(): Element | null;
    render(): React.ReactPortal | null;
}
